<!DOCTYPE html>
<html lang="en">
<head>
  <title>Making Tweet</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
  <!-- <link rel="stylesheet" type="text/css" href="../styles/create_post.css"> -->

  <link rel="stylesheet" type="text/css" href="../assets/css/emojionearea.css">

  <script type="text/javascript" src="../assets/js/emojionearea.js"></script>

  <style type="text/css">
    .alert {
       display: none;
    }
  </style>
</head>
<body>
<br>
<hr>
<div class="container">
  <div class="w3-container w3-blue w3-blue">
    <h2>Let's make a Tweet</h2>

  </div>
  <br>
  <hr>
  <form class="w3-container" name="linkedin-form" id='twitter-form-id' onsubmit="return getDataToPostOnTwitter(event)">
<!--     <p>
      <label>Comment*</label>
      <input class="w3-input" type="text" id='comment' name='comment'>
    </p> -->
     
    <p>
      <label>Write your Tweet (status)</label>
      <textarea class="w3-input" type="text" id='statusMsg' name='statusMsg' rows="10" maxlength="140"></textarea>
    </p>

    <p>
      <label>Media</label>
      <input class="w3-input" type="text" id='mediaPath' name='mediaPath'>
    </p>

    <button class="w3-btn w3-blue" type="submit">Tweet now</button></p>
  </form>
  <br>
  <br>
  <hr>

<div class="row">
  <div class="col-md-6">
      <img style="display: none" id='img' height="600px">
  </div>
  <div class="col-md-6">
      <iframe style="display: none" id='preview' height="600px"></iframe>
  </div>
</div>
  <div class="alert alert-success" id='linkedin-success'>
    <strong>Success!</strong> Indicates a successful or positive action.
  </div>

  <div class="alert alert-danger" id='linkedin-error'>
    <strong>Error!</strong> Something bad happened
  </div>
</div>

<script type="text/javascript">
function postNowOnTwitter({
    statusMsg, mediaPath
  }) {
      const {twitter} = require("../app/secrets");
      // var type = "POST";

      // Creating client
      var Twitter = require('twitter');
      console.log(twitter);
      alert('About to post');

      var client = new Twitter({
          // consumer_key: process.env.TWITTER_CONSUMER_KEY,
          consumer_key: twitter.consumerApiKey,

          // consumer_secret: process.env.TWITTER_CONSUMER_SECRET,
          consumer_secret: twitter.consumerApiSecretKey,

          // access_token_key: process.env.TWITTER_ACCESS_TOKEN_KEY,
          access_token_key: twitter.accessToken,

          // access_token_secret: process.env.TWITTER_ACCESS_TOKEN_SECRET
          access_token_secret: twitter.accessTokenSecret
      });
      
      // Load image
      var data = require('fs').readFileSync(mediaPath);

      console.log(data);
      alert('Successfully read media');

      // Make post request on media endpoint. Pass file data as media parameter
      client.post('media/upload', {media: data}, function(error, media, response) {
        if (!error) {

          // If successful, a media object will be returned.
          console.log(media);

          // Lets tweet it
          var status = {
            status: statusMsg,
            media_ids: media.media_id_string // Pass the media id string
          }

          client.post('statuses/update', status, function(error, tweet, response) {
            if (!error) {
              console.log(tweet);
            } else {
              console.log(`Error ${tweet}`);
            }
          });

        }
      });
}


/*
var obj = {
        headers: headers,
        type: method,
        url: url,
        dataType: dataType,
        contentType: contentType,
        data: data,
        success: success,
        error: error
      };
      */

function getDataToPostOnTwitter(event) {
  event.preventDefault();

  let everythingIsOk = true;
  let dataArr = $('#twitter-form-id').serializeArray();

  console.log(dataArr);
  let dataObj = {};
  for(let o of dataArr) {
    dataObj[o.name] = o.value;
  }

  console.log(dataObj);
  console.log('Giving a try'); 
  
  try{
    postNowOnTwitter(dataObj);
  } catch(error) {
    console.log(`${error}`);
  }
  console.log('Done!!!');
}


function activateemojiOneArea() {
  $(document).ready(function() {
    // $("#comment").emojioneArea();

    $("#statusMsg").emojioneArea({
         position: "bottom"
    });
        
    console.log('Emoji support activated');
  });
}
activateemojiOneArea()


// function setImage() {
//   console.log('Set Image');
//   let img = document.getElementById('img');
//   img.style.display = "block";
//   console.log(url);
//   img.src = url;
// }

// function setPreview() {
//   console.log('Set Image');
//   let preview = document.getElementById('preview');
//   preview.style.display = "block";
//   let url = document.getElementById('submittedUrl').value;
//   console.log(url);
//   preview.src = url;
// }
</script>
</body>
</html>